#!/usr/bin/perl
#
# Script to patch ABC80 rom with checksum 9913 to support 80 column text
#

use bytes;

open(ROM, "< abcbasic.rom");
binmode(ROM);
read(ROM, $rom, 16384);
close(ROM);

substr($rom, 0x01d8, 1) = pack("C", 80);
substr($rom, 0x0211, 1) = pack("C", 80);
substr($rom, 0x024f, 1) = pack("C", 80);
substr($rom, 0x022e, 1) = pack("C", 80);
substr($rom, 0x033c, 1) = pack("C", 80);
substr($rom, 0x121e, 1) = pack("C", 80);
substr($rom, 0x12a6, 1) = pack("C", 80);
substr($rom, 0x1343, 1) = pack("C", 80);
substr($rom, 0x1a71, 1) = pack("C", 80);
substr($rom, 0x1ac5, 1) = pack("C", 80);
substr($rom, 0x22f2, 1) = pack("C", 80*2); # setdot/clrdot/dot

for ( $i = 0 ; $i < 24; $i++ ) {
    $a = 0x7800 + (($i >> 3)*5 << 4) + (($i & 7) << 8);
    substr($rom, 884+2*$i, 2) = pack("v", $a);
}

open(ROM80, "> abcbas80.bin");
binmode(ROM80);
print ROM80 $rom;
close(ROM80);
